Package: org.codehaus.groovy.transform

## [Java] Class CategoryASTTransformation

- org.codehaus.groovy.transform.CategoryASTTransformation

- All Implemented Interfaces and Traits:
    ASTTransformation, org.objectweb.asm.Opcodes

      @GroovyASTTransformation(phase = CompilePhase.CANONICALIZATION)
      public class CategoryASTTransformation
      extends Object

  Handles generation of code for the

  Category:
    annotation.

    Transformation logic is as follows:

    - all non-static methods converted to static ones with an additional 'self' parameter
    - references to 'this' changed to the additional 'self' parameter
  Authors:
    Alex Tkachman

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `visit(ASTNode[] nodes, SourceUnit source)` Property invocations done on 'this' reference are transformed so that the invocations at runtime are done on the additional parameter 'self'

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, toString, hashCode, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### public void visit(ASTNode[] nodes, SourceUnit source)

      Property invocations done on 'this' reference are transformed so that the invocations at runtime are done on the additional parameter 'self'